$(document).ready(function(){
    $('.add_bloc').click(function(){
        let var1 = localStorage.getItem('modificationsNonEnregistrees');
        let var2 = localStorage.getItem('editor_content_change');

        if (var1 == 'true' || var2 == 'true') {
            Swal.fire({
                text: "Vous avez des modifications non enregistrées. Enregistrez-les avant de faire une autre action" ,
                icon: "warning",
                showCancelButton: true,
                buttonsStyling: false,
                confirmButtonText: "Continuer",
                cancelButtonText: "Fermer",
                customClass: {
                    confirmButton: "btn btn-danger",
                    cancelButton: "btn btn-light"
                }
            }).then(function (result) {
                if (result.value) {
                    $('#offcanvasExample').offcanvas('show');
                }else if (result.dismiss === 'cancel') {}
            });
        }else{
            $('#offcanvasExample').offcanvas('show');
        }


    });

    $("#BlockContent li").click(function() {
        $("#BlockContent li").removeClass('active');
        $(this).addClass('active');
    });

    $("#WidgetContent li").click(function() {
        $("#WidgetContent li").removeClass('active');
        $(this).addClass('active');
    });

    
    $("#model_service li").click(function() {
        $("#model_service li").removeClass('active');
        $(this).addClass('active');
    });


    $("#builder-forms li").click(function() {
        $("#builder-forms li").removeClass('active');
        $(this).addClass('active');
    });

    $("#media-galleries li").click(function() {
        $("#media-galleries li").removeClass('active');
        $(this).addClass('active');
    });

    
    $("#widget li").click(function() {
        $("#widget li").removeClass('active');
        $(this).addClass('active');
    });

    $("#sortable").sortable({
        connectWith: '.sortable',
        vertical: true,
        update: function(event, ui) {
            var order = $("#sortable").sortable("toArray");
            $.ajax({
                url: "/console/categorie/order-bloc",
                type: "POST",
                data: {bloc_order:order.join(",")},
                success:function(data){
                    showAlertMessage('success','La position de bloc a été changée avec succès!');
                }
            });
        }
    });

    $('.btn-etat-bloc').click(function () { 
        var element = $(this);
        var id = $(this).attr('data-id');
        $.ajax({
            url: "/console/categorie-bloc/change_etat",
            type: "POST",
            data: {id:id},
            success:function(data){
                showAlertMessage('success','L\'etat de bloc a été changée avec succès!');
                if (element.parent().parent().find('.collapsed .badge').hasClass('badge-success')) {
                    element.parent().parent().find('.collapsed .badge').removeClass('badge-success');
                    element.parent().parent().find('.collapsed .badge').addClass('badge-danger');
                    element.parent().parent().find('.collapsed .badge').text('désactive');
                }else{
                    element.parent().parent().find('.collapsed .badge').removeClass('badge-danger');
                    element.parent().parent().find('.collapsed .badge').addClass('badge-success');
                    element.parent().parent().find('.collapsed .badge').text('activé');
                }
        
                if(element.parent().parent().find('.btn-etat-bloc i').hasClass('fa-eye-slash')){
                    element.parent().parent().find('.btn-etat-bloc i').removeClass('fa-eye-slash');
                    element.parent().parent().find('.btn-etat-bloc i').addClass('fa-eye');
                }else{
                    element.parent().parent().find('.btn-etat-bloc i').removeClass('fa-eye');
                    element.parent().parent().find('.btn-etat-bloc i').addClass('fa-eye-slash');
                }
            }
        });
    });

    $('.btn-detect-bloc').click(function () { 
        var element = $(this);
        var id = $(this).attr('data-id');
        var type = $(this).attr('data-type');

        $.ajax({
            url: "/console/categorie-bloc/change-etat-mobile-desktop",
            type: "POST",
            data: {id:id,type:type},
            success:function(data){
                showAlertMessage('success','Etat du bloc a été changé avec succès');
                if (element.find('.fa').hasClass('color-active')) {
                    element.find('.fa').removeClass('color-active');
                    element.find('.fa').addClass('color-inactive');
                }else{
                    element.find('.fa').removeClass('color-inactive');
                    element.find('.fa').addClass('color-active');
                }
            }
        });
    });
});


function RemoveBloc(index,idBloc = null){
    Swal.fire({
        text: "Voulez-vous supprimer cet élément ?",
        icon: "warning",
        showCancelButton: true,
        buttonsStyling: false,
        confirmButtonText: "Oui, supprimer!",
        cancelButtonText: "Non, annuler",
        customClass: {
            confirmButton: "btn fw-bold btn-danger",
            cancelButton: "btn fw-bold btn-active-light-primary"
        }
    }).then(function (result) {
        if (result.value) {
            $.ajax({
                url: "/console/categorie/remove-bloc",
                type: "POST",
                data: {Idbloc:idBloc},
                success:function(data){
                    showAlertMessage('success','Votre bloc a été supprimé avec succès!');
                    $('.del-bloc'+index).remove();
                }
            });
        } else if (result.dismiss === 'cancel') {}
    });
}

function ChoiceField(type) {  
    $('#offcanvasExample').offcanvas('hide');
    

    if (type == 'texte') {
        var $modal = $('#modal-add-bloc-text');
        $('#modal-add-bloc-text').modal('show');
    } 

    if (type == 'link') {
        var $modal = $('#modal-add-bloc-lien');
        $('#modal-add-bloc-lien').modal('show');
    } 

    if (type == 'image') {
        var $modal = $('#modal-add-bloc-image');
        $('#modal-add-bloc-image').modal('show');
    } 

    if (type == 'editeur') {
        var $modal = $('#modal-add-bloc-editeur');
        $('#modal-add-bloc-editeur').modal('show');
    } 

    if (type == 'video') {
        var $modal = $('#modal-add-bloc-video');
        $('#modal-add-bloc-video').modal('show');
    } 

    if (type == 'editeur2') {
        var $modal = $('#modal-add-bloc-text-image');
        $('#modal-add-bloc-text-image').modal('show');
    }

    if (type == 'forms') {
        var $modal = $('#modal-add-bloc-form');
        $('#modal-add-bloc-form').modal('show');
    }

    if (type == 'widget') {
        var $modal = $('#modal-add-bloc-widget');
        $('#modal-add-bloc-widget').modal('show');
    }

    if (type == 'media') {
        var $modal = $('#modal-add-bloc-gallery');
        $('#modal-add-bloc-gallery').modal('show');
    }
    
    if (type == 'text_maps') {
        var $modal = $('#modal-add-bloc-text-maps');
        $('#modal-add-bloc-text-maps').modal('show');
    }

    if (type == 'service') {
        var $modal = $('#modal-add-bloc-services');
        $('#modal-add-bloc-services').modal('show');
    }

    if (type == 'partenaire') {
        var $modal = $('#modal-add-bloc-partenaire');
        $('#modal-add-bloc-partenaire').modal('show');
    }

    if (type == 'activite') {
        var $modal = $('#modal-add-bloc-activite');
        $('#modal-add-bloc-activite').modal('show');
    }

    if (type == 'localite') {
        var $modal = $('#modal-add-bloc-localite');
        $('#modal-add-bloc-localite').modal('show');
    }

    if (type == 'sous_activite') {
        var $modal = $('#modal-add-bloc-sous-activite');
        $('#modal-add-bloc-sous-activite').modal('show');
    }

    if (type == 'galeries') {
        var $modal = $('#modal-add-galeries');
        $('#modal-add-galeries').modal('show');
        $("#modal-add-galeries #sortable_image_gallerie").sortable({
            connectWith: '.sortable',
            vertical: true,
            update: function(event, ui) {
                //var order = $("#sortable_image_gallerie").sortable("toArray");
                //console.log(order);
            }
        });
    }
    
    
    if ($modal.data('result') !== 'yes') {
        event.preventDefault();
        $modal
            .off('click', '#btnYes')
            .on('click', '#btnYes', function () {
                    var NbBloc = $(".list-bloc").attr('data-nb-bloc');
                    var id_categorie = $('#IdCategorie').val();
                    var type =  $modal.find('input[name="type_bloc"]').val();
                    var index = parseInt(NbBloc) + 1;

                    // bloc Texte
                    if (type == '1') {
                        var titre =  $modal.find('input[name="titre"]').val();
                        var contenu =  $modal.find('textarea[name="editeur"]').val();
                        var titre_lien = $modal.find('input[name="titre_lien_bloc"]').val();
                        var type_lien = $modal.find('input[name="type_lien_bloc"]:checked').val();
                        var lien_interne_bloc = $modal.find('select[name="lien_interne_bloc"]').val();
                        var lien_externe_bloc = $modal.find('input[name="lien_externe_bloc"]').val();
                        var telephone_bloc = $modal.find('input[name="telephone_bloc"]').val();
                        var bg_color = $modal.find('input[name="bg_color"]').val();

                        if (titre == '' || contenu == '') {
                            showAlertMessage('error','Veuillez remplir le champ obligatoire!');
                            return false;
                        }else{
                            var formData = { position:index,id_categorie:id_categorie,
                                             type_bloc:type,titre: titre,contenu:contenu,
                                             titre_lien:titre_lien,
                                             type_lien:type_lien,
                                             lien_interne_bloc:lien_interne_bloc,
                                             lien_externe_bloc:lien_externe_bloc,
                                             telephone_bloc:telephone_bloc,
                                             bg_color:bg_color
                                           };
                        }
                    }

                    // bloc Lien
                    if (type == '2') {
                        var titre =  $modal.find('input[name="titre"]').val();
                        var link =  $modal.find('input[name="link"]').val();

                        if (titre =='' || link =='') {
                            showAlertMessage('error','Veuillez remplir le champ obligatoire!');
                            return false;
                        }else{
                            var formData = { position:index,id_categorie:id_categorie,
                                             type_bloc:type,titre: titre,link:link};
                        }
                    }

                    // bloc image
                    if (type == '3') {
                        var titre =  $modal.find('input[name="titre"]').val();
                        var image =  $modal.find('input[name="image"]').val();

                        if (titre =='' || image =='') {
                            showAlertMessage('error','Veuillez remplir le champ obligatoire!');
                            return false;
                        }else{
                            var formData = { position:index,id_categorie:id_categorie,
                                             type_bloc:type,titre: titre,image:image};
                        }
                    }

                    // bloc image
                    if (type == '4') {
                        var contenu =  $modal.find('textarea[name="editeur"]').val();

                        if (contenu =='') {
                            showAlertMessage('error','Veuillez remplir le champ obligatoire!');
                            return false;
                        }else{
                            var formData = { position:index,id_categorie:id_categorie,
                                             type_bloc:type,contenu:contenu};
                        }
                    }

                    // bloc video
                    if (type == '9') {
                        var lien_video =  $modal.find('input[name="bloc_video_url"]').val();

                        if (lien_video =='') {
                            showAlertMessage('error','Veuillez remplir le champ obligatoire!');
                            return false;
                        }else{
                            var formData = { position:index,id_categorie:id_categorie,
                                             type_bloc:type,video:lien_video};
                        }
                    }

                    // bloc texte + image
                    if (type == '10') {
                        var titre_editeur =  $modal.find('input[name="titre"]').val();
                        var contenu_editeur =  $modal.find('.editeur3_contentBloc').val();
                        var position_editeur =  $modal.find('.editeur3_position option:selected').val();
                        var image_editeur =  $modal.find('input[name="editeur3_image"]').val();
                        var video_editeur =  $modal.find('input[name="editeur3_video_url"]').val();
                        var grid_image =  $modal.find('.grid_image option:selected').val();

                        if (titre =='' || contenu =='') {
                            showAlertMessage('error','Veuillez remplir le champ obligatoire!');
                            return false;
                        }else{
                            var formData = { position:index,id_categorie:id_categorie,
                                             type_bloc:type,titre_editeur:titre_editeur,contenu_editeur:contenu_editeur,
                                             position_editeur:position_editeur,image_editeur:image_editeur,video_editeur:video_editeur,
                                             grid_image:grid_image
                                           };
                        }
                    }

                    // bloc form
                    if(type == '6'){
                        var widget =  $modal.find('#builder-forms .active input[name="moduleId"]').val();
                        if (widget == undefined) {
                            showAlertMessage('error','Veuillez remplir le champ obligatoire!');
                            return false;
                        }else{
                            var formData = { position:index,id_categorie:id_categorie,type_bloc:type,
                                             widget:widget
                                           };
                        }
                    }

                    // bloc widget
                    if(type == '8'){
                        var widget =  $modal.find('#model_widget .active input[name="moduleId"]').val();
                        if (widget == undefined) {
                            showAlertMessage('error','Veuillez remplir le champ obligatoire!');
                            return false;
                        }else{
                            var formData = { position:index,id_categorie:id_categorie,type_bloc:type,
                                             widget:widget
                                           };
                        }
                    }

                    // bloc media
                    if(type == '5'){
                        var widget =  $modal.find('#media-galleries .active input[name="moduleId"]').val();
                        if (widget == undefined) {
                            showAlertMessage('error','Veuillez remplir le champ obligatoire!');
                            return false;
                        }else{
                            var formData = { position:index,id_categorie:id_categorie,type_bloc:type,
                                             widget:widget
                                           };
                        }
                    }
            
                    // bloc Texte + maps
                    if (type == '11') {
                        var titre =  $modal.find('input[name="titre"]').val();
                        var contenu =  $modal.find('textarea[name="editeur"]').val();

                        if (titre == '' || contenu == '') {
                            showAlertMessage('error','Veuillez remplir le champ obligatoire!');
                            return false;
                        }else{
                            var formData = { position:index,id_categorie:id_categorie,type_bloc:type,titre: titre,contenu:contenu};
                        }
                    }

                    // bloc service
                    if(type == '11'){
                        var bloc_service =  $modal.find('#model_service .active input[name="moduleId"]').val();
                        if (bloc_service == undefined) {
                            showAlertMessage('error','veuillez choisir un bloc!');
                            return false;
                        }else{
                            var formData = { position:index,
                                             id_categorie:id_categorie,
                                             type_bloc:type,
                                             id_bloc_service:bloc_service
                                            };
                        }
                    }

                    // bloc partenaire
                    if(type == '12'){
                        var formData = { 
                            position:index,
                            id_categorie:id_categorie,
                            type_bloc:type,
                        };
                    }

                    // bloc activite
                    if(type == '13'){
                        var type_affichage =  $modal.find('#type_affichage input[name="multi_affichage"]:checked').val();
                        if (type_affichage == undefined) {
                            showAlertMessage('error','veuillez choisir un affichage!');
                            return false;
                        }else{
                            var formData = { 
                                position:index,
                                id_categorie:id_categorie,
                                type_bloc:type,
                                type_affichage:type_affichage
                            };
                        }
                    }

                    // bloc localite
                    if(type == '14'){
                        var type_affichage =  $modal.find('#type_affichage input[name="multi_affichage"]:checked').val();
                        if (type_affichage == undefined) {
                            showAlertMessage('error','veuillez choisir un affichage!');
                            return false;
                        }else{
                            var formData = { 
                                position:index,
                                id_categorie:id_categorie,
                                type_bloc:type,
                                type_affichage:type_affichage
                            };
                        }
                    }

                    // bloc sous activite
                    if(type == '15'){
                        var type_affichage =  $modal.find('#type_affichage input[name="multi_affichage"]:checked').val();
                        if (type_affichage == undefined) {
                            showAlertMessage('error','veuillez choisir un affichage!');
                            return false;
                        }else{
                            var formData = { 
                                position:index,
                                id_categorie:id_categorie,
                                type_bloc:type,
                                type_affichage:type_affichage
                            };
                        }
                    }

                    
                    // bloc gallerie 
                    if(type == '16'){
                        var model_affichage =  $modal.find('#modele_galleries .item-gallerie.selected').attr('data-id'); 
                        var ids_images = $modal.find('.file-preview input[name="image_id[]"]').map(function(){
                            return this.value;
                        }).get();

                        var titre =  $modal.find('input[name="titre"]').val();
                        var titre_lien = $modal.find('input[name="titre_lien_bloc"]').val();
                        var type_lien = $modal.find('input[name="type_lien_bloc"]:checked').val();
                        var lien_interne_bloc = $modal.find('select[name="lien_interne_bloc"]').val();
                        var lien_externe_bloc = $modal.find('input[name="lien_externe_bloc"]').val();
                        var telephone_bloc = $modal.find('input[name="telephone_bloc"]').val();
                        var contenu_editeur =  $modal.find('.contentBloc').val();

                        if (model_affichage == undefined) {
                            showAlertMessage('error','Merci de choisir un affichage et de sélectionner les images.');
                            return false;
                        }else if(ids_images.length <= 0){
                            showAlertMessage('error','Merci de choisir un affichage et de sélectionner les images.');
                            return false;
                        }else{
                            var formData = { 
                                position:index,
                                id_categorie:id_categorie,
                                type_bloc:type,
                                model_affichage:model_affichage,
                                ids_images: ids_images.join(','),
                                contenu_editeur:contenu_editeur,
                                titre:titre,
                                titre_lien:titre_lien,
                                type_lien:type_lien,
                                lien_interne:lien_interne_bloc,
                                lien_externe:lien_externe_bloc,
                                telephone:telephone_bloc,
                            };
                        }
                    }

                    $(this).find('i').removeClass('fa fa-plus').addClass('fa fa-spinner fa-spin');
                    $.ajax({
                        url: "/console/categorie/add-bloc",
                        type: "POST",
                        data: formData,
                        success:function(data){
                          location.reload();
                        }
                    });
            });
    }
}

function editGalerieBloc(id,type){

    var $modal = $('#modal-edit-galeries');
    $.ajax({
        url: '/console/edit-bloc-gallerie/'+id+'/'+type,
        type: "GET",
        success:function(data){
            $modal.modal('show');
            $modal.find('.modal-body').html(data);
            $("#sortable_image_gallerie").sortable({
                connectWith: '.sortable',
                vertical: true,
                update: function(event, ui) {
                    //var order = $("#sortable_image_gallerie").sortable("toArray");
                    //console.log(order);
                }
            });
        }
    });

    if ($modal.data('result') !== 'yes') {
        event.preventDefault();
        $modal
            .off('click', '#btnYes')
            .on('click', '#btnYes', function () {
    
                    var model_affichage =  $modal.find('#modele_galleries .item-gallerie.selected').attr('data-id'); 
                    var ids_images = $modal.find('.file-preview input[name="image_id[]"]').map(function(){
                        return this.value;
                    }).get();

                    var titre =  $modal.find('input[name="titre"]').val();
                    var titre_lien = $modal.find('input[name="titre_lien_bloc"]').val();
                    var type_lien = $modal.find('input[name="type_lien_bloc"]:checked').val();
                    var lien_interne_bloc = $modal.find('select[name="lien_interne_bloc"]').val();
                    var lien_externe_bloc = $modal.find('input[name="lien_externe_bloc"]').val();
                    var telephone_bloc = $modal.find('input[name="telephone_bloc"]').val();
                    var contenu_editeur =  $modal.find('.contentBloc').val();

                    if (model_affichage == undefined) {
                        showAlertMessage('error','Merci de choisir un affichage et de sélectionner les images.');
                        return false;
                    }else if(ids_images.length <= 0){
                        showAlertMessage('error','Merci de choisir un affichage et de sélectionner les images.');
                        return false;
                    }else{
                        var formData = { 
                            model_affichage:model_affichage,
                            ids_images: ids_images.join(','),
                            titre:titre,
                            contenu_editeur:contenu_editeur,
                            titre_lien:titre_lien,
                            type_lien:type_lien,
                            lien_interne:lien_interne_bloc,
                            lien_externe:lien_externe_bloc,
                            telephone:telephone_bloc,
                        };
                    }
                
                    $(this).find('i').removeClass('fa fa-edit').addClass('fa fa-spinner fa-spin');
                    $.ajax({
                        url: '/console/edit-bloc-gallerie/'+id+'/'+type,
                        type: "POST",
                        data: formData,
                        success:function(data){
                           location.reload();
                        }
                    });
            });
    }
}